{$F+}

unit
  UDefault;

interface

uses
  Dos, UZ80Var, UKBD, XLIB2, UGraph, UStrings, UZ80, XBM2;

procedure SaveGIFProc;
procedure DefaultInfo(nPage: Integer);
procedure DefaultCheckKeyboard;
procedure NullOutByte(nEnder, nValue: Word);
function NullInByte(nPort: Word): Byte;
procedure NullInterrupt;

implementation

uses
  xGif2, UCharSet;

var
  aPal: PByteArray;
  nXGif, nYGif: Integer;


procedure NullOutByte(nEnder, nValue: Word);
begin
end;

function NullInByte(nPort: Word): Byte;
begin
end;


function GetGIFPixel: Integer;
begin
  if nXGif>=GetMaxX then begin
    Inc(nYGIF);
    if nYGIF>=GetMaxY then begin
      GetGIFPixel := -1;
      exit
    end;
    nXGif := 0;
  end;
  GetGIFPixel := xgetpix(nXGif, nYGIF, VisiblePageOffs);
  inc(nXGIF);
end;

procedure SaveGIFProc;
var
  I: Integer;
  S: SearchRec;
begin
  GetMem(aPal, 256*3);
  XGetPalRaw(aPal^, 256, 0);

  nXGif := 0;
  nYGif := 0;
  GifInPixelProc := GetGifPixel;

  for i := 0 to 99 do begin
    FindFirst('EMUL'+sStrZero(i, 2)+'.GIF', ANYFILE, S);
    if DosError=18 then begin
      break;
    end;
  end;
  SaveGIF('EMUL'+sStrZero(i mod 100, 2)+'.GIF', GetMaxX, GetMaxY, 8, aPal^);

  FreeMem(aPal, 256*3);
end;

procedure DefaultCheckKeyboard;
begin
  if oKBD.Key(kESC) then lStopEmulation := true;
  if oKBD.Key(kF2) then begin
    aProcs[1].nIM := 0;
    aProcs[1].nHalted := 0;
    aProcs[1].nPendingNMI := 1;
    aZ80Regs^.IFF1 := 1;
    aZ80Regs^.IFF2 := 1;
    aZ80Regs^.SP.W := $4F00;
    aZ80Regs^.PC.W := $0000;
  end;
  if oKBD.Key(kF3) then begin
    while oKBD.Key(kf3) do;
    ShowCharSet(false);
  end;
  if oKBD.Key(kF4) then begin
    while oKBD.Key(kf4) do;
    ShowCharSet(true);
  end;
  if oKBD.Key(kF8) then lDumpReg := true;
  if oKBD.Key(kF9) then lDumpReg := false;
  if oKBD.Key(kF10) then lSlow := true;
  if oKBD.Key(kF6) then begin
    while oKBD.Key(kf6) do;
    SaveGIFProc;
  end;
end;

procedure DefaultInfo(nPage: Integer);
begin
  xRectFill(GetMaxX-080, 10, GetMaxX-10, 150, nPage, nLightGray);
  Border(GetMaxX-080, 10, GetMaxX-10, 150, nPage, false);
  OutTextXY(GetMaxX-071, 14, 'REGISTERS', nBlack, nWhite, nPage);
  xPrintf(GetMaxX-075,  30, nPage, nBlack, 'AF='+ToHex(aZ80Regs^.AF.W, 4));
  xPrintf(GetMaxX-075,  40, nPage, nBlack, 'BC='+ToHex(aZ80Regs^.BC.W, 4));
  xPrintf(GetMaxX-075,  50, nPage, nBlack, 'DE='+ToHex(aZ80Regs^.DE.W, 4));
  xPrintf(GetMaxX-075,  60, nPage, nBlack, 'HL='+ToHex(aZ80Regs^.HL.W, 4));
  xPrintf(GetMaxX-075,  70, nPage, nRed, 'PC='+ToHex(aZ80Regs^.PC.W, 4));
  xPrintf(GetMaxX-075,  80, nPage, nRed, 'SP='+ToHex(aZ80Regs^.SP.W, 4));
  xPrintf(GetMaxX-075,  90, nPage, nBlue, 'IFF1='+ToHex(aZ80Regs^.IFF1, 2));
  xPrintf(GetMaxX-075, 100, nPage, nBlue, 'IFF2='+ToHex(aZ80Regs^.IFF2, 2));
  xPrintf(GetMaxX-075, 110, nPage, nBlue, 'HALT='+ToHex(aProcs[1].nHalted, 2));
  xPrintf(GetMaxX-075, 120, nPage, nBlue, 'IM='+ToHex((aProcs[1].nIM), 2));

  xRectFill(GetMaxX-080, 155, GetMaxX-10, 245, nPage, nYellow);
  Border(GetMaxX-080, 155, GetMaxX-10, 245, nPage, false);

  OutTextXY(GetMaxX-077, 160, 'F1', nWhite, nBlack, nPage);
  xPrintf(GetMaxX-075+12, 160, nPage, nBlue, 'Help On');

  OutTextXY(GetMaxX-077, 170, 'F2', nWhite, nBlack, nPage);
  xPrintf(GetMaxX-075+12, 170, nPage, nBlue, 'Reset');

  OutTextXY(GetMaxX-077, 180, 'F3', nWhite, nBlack, nPage);
  xPrintf(GetMaxX-075+12, 180, nPage, nBlue, 'CharSets');

  OutTextXY(GetMaxX-077, 190, 'F4', nWhite, nBlack, nPage);
  xPrintf(GetMaxX-075+12, 190, nPage, nBlue, 'Sprites');

  OutTextXY(GetMaxX-077, 200, 'F5', nWhite, nBlack, nPage);
  xPrintf(GetMaxX-075+12, 200, nPage, nBlue, 'DSW');

  OutTextXY(GetMaxX-077, 210, 'F6', nWhite, nBlack, nPage);
  xPrintf(GetMaxX-075+12, 210, nPage, nBlue, 'Scr Shot');

  xPrintf(GetMaxX-090, GetMaxY-20, nPage, nYellow, 'PASMULATOR 0.1');
  xPrintf(GetMaxX-090, GetMaxY-10, nPage, nYellow, 'by pscardoso');
end;

procedure NullInterrupt;
begin
  DefaultCheckKeyboard;
  if (nXPos<8) then begin
    DefaultInfo(HIDDENPAGEOFFS);
  end;


  {
  if lShowMouse then
    xPutMaskedLBM(MouseX, MouseY, HiddenPageOffs,
      oLBMCur^.nW, oLBMCur^.nH, 0, @oLBMCur^.aData);
  }
    {xPutCBitMap(MouseX, MouseY, HiddenPageOffs, oCursor.oEnd^);}

  if lShowMouse then xHideMouse;
  XPageFlip(0, 0);
  if lShowMouse then begin
    MouseColor := Random(256);
    xShowMouse;
  end;

  if nMoving<>0 then begin
    nXPos := nXPos+nMoving;
    if nXPos<8 then nMoving := 0;
    if nXPos=((GetMaxX-oROMSInfo.nVW*8) div 2) then begin
      lShowMouse := false;
      lShowCPU := false;
      nMoving := 0;
      xHideMouse;
    end;
  end
  else begin
    if (MouseButtonStatus<>0) or oKBD.Key(kF1) then begin
      if nXPos<8 then
        nMoving := 1
      else
        nMoving := -1;
      while (MouseButtonStatus<>0) or oKBD.Key(kF1) do;
      lShowMouse := true;
      lShowCPU := true;
      xShowMouse;
    end;
  end;
end;


end.