{$O+}
unit
  UFrogger;

interface

uses
  UZ80Var, UKBD, XLIB2, UGraph, UStrings, UZ80, XBM2, UDefault;

  function FroggerGetByte(nEnder: Word): Byte;
  procedure FroggerPutByte(nEnder, nValue: Word);
  procedure FroggerInterrupt;
  function FroggerInByte(nEnder: Word): Byte;


implementation

procedure FroggerPutByte(nEnder, nValue: Word);
begin
  aZ80Mem^[nEnder] := nValue
end;

function FroggerGetByte(nEnder: Word): Byte;
var
  RV: Byte;
begin
  if nEnder=$E000 then begin
    rv := $FF;
    if oKBD.Key(k3)    then rv  := rv and $7F;
    if oKBD.Key(k4)    then rv  := rv and $BF;
    if oKBD.Key(klf)   then rv  := rv and $DF;
    if oKBD.Key(krt)   then rv  := rv and $EF;
    if oKBD.Key(kctrl) then rv  := rv and $F7;
    if oKBD.Key(kC)    then rv  := rv and $FB;
    if oKBD.Key(kAlt)  then rv  := rv and $FD;
    if oKBD.Key(kW)    then rv  := rv and $FE;
    FroggerGetByte := rv;
    exit
  end;

  if nEnder=$E002 then begin
    rv := $FF;
    {$ifndef DEBUG}
    if oKBD.Key(k1)      then rv  := rv and $7F;
    if oKBD.Key(k2)      then rv  := rv and $BF;
    if oKBD.Key(kA)      then rv  := rv and $CF;
    if oKBD.Key(kD)      then rv  := rv and $EF;
    if oKBD.Key(kTab)    then rv  := rv and $F7;
    if oKBD.Key(kLShift) then rv  := rv and $FB;
    {$endif}
    FroggerGetByte := rv;
    exit
  end;

  if nEnder=$E004 then begin
    rv := $FF;
    {$ifndef DEBUG}
    if oKBD.Key(kdn)   then rv  := rv and $BF;
    if oKBD.Key(kup)   then rv  := rv and $EF;
    if oKBD.Key(kS)    then rv  := rv and $FE;
    {$endif}
    FroggerGetByte := rv;
    exit
  end;

  FroggerGetByte := aZ80Mem^[nEnder];
end;


function FroggerInByte(nEnder: Word): Byte;
var
  RV: Byte;
begin
  FroggerInByte := $FF;
end;


procedure FroggerInterrupt;
var
  nChar, nSprite, nEnder, i, j, nty, x, y, c, nDeltaY: LongInt;
  nY, nSX, nSY, nColor, nTotalX, nOffSetValue, nScanLine, nPos, nShift: LongInt;
begin

  xRectFill(0, 0, GetMaxX, GetMaxY, HIDDENPAGEOFFS, nBLACK);
  if nXPos<=8 then
    Border(nXPos-2, nYPos-2, nXPos+32*8+2, nYPos+32*8+2, HIDDENPAGEOFFS, false);

  for y := 0 to 31 do begin
    if oROMSInfo.lInvertY then begin
      nY := (31-Y);
    end
    else begin
      nY := Y;
    end;
    nSY := nY*8;
    if oROMSInfo.lShift then begin
       nShift := aZ80Mem^[oROMSInfo.nShiftAddr+2*nY];
       nShift := ((nShift shl 4) and $F0) or ((nShift shr 4) and $0F)
    end
    else
      nShift := 0;

    nColor := (aZ80Mem^[$5800+2*nY+1] and 7)*4;

    for x := 0 to 31 do begin
      if oROMSInfo.lInvertX then
        nOffSetValue := aZ80Mem^[oROMSInfo.nVRAM+(31-x)*32+nY]
      else
        nOffSetValue := aZ80Mem^[oROMSInfo.nVRAM+x*32+nY];

      if nOffSetValue<>16 then begin
        nSX := (x*8+nShift) mod 256;
        xPutMaskedLBM(nXPos+nSX, nYPos+nSY, HiddenPageOffs, 8, 8, nColor, aLBMChars[nOffSetValue]);
      end;

    end;
  end;


  nEnder := $B05F-3;
  while nEnder>=$B040 do begin
    if aZ80Mem^[nEnder+3]<>0 then begin
      X := aZ80Mem^[nEnder];
      X := ((X shl 4) and $f0) or ((X shr 4) and $0f);
      Y := aZ80Mem^[nEnder+3];
      nSprite := aZ80Mem^[nEnder+1] and $3F;
      xPutMaskedLBM(nXPos+X, nYPos+Y, HiddenPageOffs, 16, 16, 0, aSprites[nSprite]);
    end;
    nEnder := nEnder-4;
  end;

  aProcs[1].nPendingNMI := 0;
  PChar(aProcs[1].nPendingIRQ)[3] := Chr(IGNORE_INT);
  if oROMSInfo.nNMIEnable<>0 then begin
    if aZ80Mem^[oROMSInfo.nNMIEnable]<>0 then begin
      aProcs[1].nPendingNMI := 1;
    end
    else begin
      aProcs[1].nPendingIRQ := $01000000;
    end;
  end;
  NullInterrupt;
end;


end.
