{$F+,S-}

Unit
  UGraph;

Interface

Uses
  XLib2,
  Dos;

Const
  MAPMASK = $02;   {index in SC of Map Mask register}
  SCINDEX = $03c4;   {; SEQUence Controller Index 1}
  dlTime   : Integer = 10;
  bmpErase = 22;
  nBlack: Byte     =  0;
  nBlue: byte       =  1;
  nGreen: Byte      =  2;
  nCyan: Byte       =  3;
  nRed: Byte        =  4;
  nMagenta: Byte    =  5;
  nBrown: Byte      =  6;
  nLightGray: byte  =  7;
  nDarkGray: Byte   = 8;
  nLightBlue: Byte  =  9;
  nLightGreen: Byte = 10;
  nLightCyan: Byte  = 11;
  nLightRed: Byte   = 12;
  nLightMagenta: Byte = 13;
  nYellow: Byte     = 14;
  nWhite: Byte     = 15;

  nLastBlack: Byte     =  0;
  nLastBlue: byte       =  1;
  nLastGreen: Byte      =  2;
  nLastCyan: Byte       =  3;
  nLastRed: Byte        =  4;
  nLastMagenta: Byte    =  5;
  nLastBrown: Byte      =  6;
  nLastLightGray: byte  =  7;
  nLastDarkGray: Byte   = 8;
  nLastLightBlue: Byte  =  9;
  nLastLightGreen: Byte = 10;
  nLastLightCyan: Byte  = 11;
  nLastLightRed: Byte   = 12;
  nLastLightMagenta: Byte = 13;
  nLastYellow: Byte     = 14;
  nLastWhite: Byte     = 15;


Type
  PPalette = ^TRGBPalette;

  TRGBColor = Record
              R,G,B : Byte
              End;

  TRGBPalette = Array [0..255] of TRGBColor;
  TRGBDefVGA  = Array [0..15 ] of TRGBColor;


  TPointerX = record
    nSize: Word;
    oEnd: Pointer;
  end;
  APointer = array[0..1024] of Pointer;
  PPointer = ^APointer;

  PLBMImage = ^TLBMImage;
  TLBMImage = record
    nW, nH: Byte;
    aData: array[0..0] of byte;
  end;

const
  MAX_BUTTON_SPRITES = 9;
  OK_SPRITE     = 1;
  CANCEL_SPRITE = 2;
  EXIT_SPRITE   = 3;
  UP_SPRITE     = 4;
  DOWN_SPRITE   = 5;
  CHECK1_SPRITE = 6;
  CHECK2_SPRITE = 7;
  RADIO1_SPRITE = 8;
  RADIO2_SPRITE = 9;
var
  aLBMChars: array[0..512] of Pointer;
  aSprites: array[0..127] of Pointer;
  oButtonSprite: array[1..MAX_BUTTON_SPRITES] of PLBMImage;

var
  aPalette: TRGBPalette;

Const
  mensQuickMessage = 0;
  mensNormMessage  = 1;
  MessageMode : Byte = mensNormMessage;
  Palette16 : TRGBDefVGA = (( R:$00; G:$00; B:$00 ), { 00 }
                            ( R:$00; G:$00; B:042 ), { 01 }
                            ( R:$00; G:042; B:$00 ), { 02 }
                            ( R:$00; G:042; B:042 ), { 03 }
                            ( R:042; G:000; B:000 ), { 04 Red }
                            ( R:042; G:$00; B:042 ), { 05 }
                            ( R:042; G:021; B:000 ), { 06 }
                            ( R:042; G:042; B:042 ), { 07 }

                            ( R:021; G:021; B:021 ), { 08 }
                            ( R:021; G:021; B:063 ), { 09 }
                            ( R:021; G:063; B:021 ), { 10 }
                            ( R:021; G:063; B:063 ), { 11 }
                            ( R:063; G:021; B:021 ), { 12 LightRed }
                            ( R:063; G:021; B:063 ), { 13 }
                            ( R:063; G:063; B:021 ), { 14 }
                            ( R:063; G:063; B:063 ));{ 15 }


Function ConvertPalette (Color:Byte; Var Palette:TRGBPalette):Byte;
Function ConvPal (A:Byte):Byte;
Procedure OutTextXY (X,Y:Word; cText:String; nColor1,nColor2:Word; nPage:Word);
Procedure ShadowPrint(X,Y,nPage,nCor1,nCor2:Word; cText:String);
Procedure Border (X1,Y1,X2,Y2,nPage:Integer; lFlag:Boolean);
Procedure xRectangle (X1,Y1,X2,Y2,nCor,nPage:Integer);
function xTextWidth(cStr: String): LongInt;
procedure xPutMaskedLBM(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer);
procedure xPutMaskedLBMFlipY(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer);
procedure xPutMaskedLBMFlipX(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer);
procedure xPutMaskedLBMFlipXY(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer);
procedure asmPutBitMap90(x, y, PgOfs: Integer; nDC: byte; oSprite: Pointer);
procedure MapSystemColor;
procedure LoadLBM(var LBMData: PLBMImage; cFileName: String);
procedure freeLBM(var LBMData: PLBMImage);
function  Bit(nByte1, nByte2: Byte): Byte;
procedure SetByte(var nValue: byte; nBit: Byte; nTipo: Integer);

Implementation

procedure LoadLBM(var LBMData: PLBMImage; cFileName: String);
var
  I, nW, nH: Integer;
  F: File;
begin
  {$I-}
  Assign(F, cFileName);
  Reset(F, 1);
  {$I+}
  if IOResult<>0 then begin
    Writeln('I can not load the icons!');
    Writeln('Failed to load '+cFileName);
    Halt(1);
  end;
  BlockRead(F, nW, 2);
  BlockRead(F, nH, 2);
  GetMem(LBMData, 2+nW*nH);
  LBMData^.nW := nW;
  LBMData^.nH := nH;
  BlockRead(F, LBMData^.aData, nW*nH);
  Close(F);
  for i := 0 to nW*nH-1 do begin
    case LBMData^.aData[i] of
        0: LBMData^.aData[i] := 16;
      255: LBMData^.aData[i] := 0;
    end;
  end;
end;


procedure freeLBM(var LBMData: PLBMImage);
var
  nSize: Word;
begin
  nSize := 2+LBMData^.nW*LBMData^.nH;
  FreeMem(LBMData, nSize);
  LBMData := nil;
end;



function Bit(nByte1, nByte2: Byte): Byte;
const
  aBytes: array[0..7] of Byte = (1,2,4,8,16,32,64,128);
begin
  if (nByte1 and aBytes[nByte2])=0 then
    Bit := 0
  else
    Bit := 1
end;


procedure SetByte(var nValue: byte; nBit: Byte; nTipo: Integer);
const
  aBytes: array[0..7] of Byte = (1,2,4,8,16,32,64,128);
begin
  if nTipo=1 then begin
    nValue := nValue and not aBytes[nBit];
  end;
  if nTipo=2 then begin
    nValue := nValue or aBytes[nBit];
  end;
end;

Function ConvertPalette (Color:Byte; Var Palette:TRGBPalette):Byte;
Var
  I,J      : Integer;
  DifAnt,
  Dif      : Real;
  NewColor : Byte;
Begin
DifAnt := 1e10;
For I := 16 to 255 do
    Begin
    Dif := Sqrt(Sqr(1.0*Palette[Color].R - 1.0*Palette[i].R)+
                Sqr(1.0*Palette[Color].G - 1.0*Palette[i].G)+
                Sqr(1.0*Palette[Color].B - 1.0*Palette[i].B));
    If Dif<DifAnt then Begin
                       NewColor := I;
                       DifAnt := Dif
                       End;
    End;

For I := 0 to 15 do
    Begin
    Dif := Sqrt(Sqr(1.0*Palette[Color].R - 1.0*Palette16[i].R)+
                Sqr(1.0*Palette[Color].G - 1.0*Palette16[i].G)+
                Sqr(1.0*Palette[Color].B - 1.0*Palette16[i].B));
    If Dif<DifAnt then Begin
                       NewColor := I;
                       DifAnt := Dif
                       End;
    End;

ConvertPalette := NewColor;
End;


Function ConvPal (A:Byte):Byte;
Begin
ConvPal := A shr 2;
End;

Procedure OutTextXY (X,Y:Word; cText:String; nColor1,nColor2:Word; nPage:Word);
Begin
 xPrintf(X-1,Y,nPage,nColor2,cText);
 xPrintf(X+1,Y,nPage,nColor2,cText);
 xPrintf(X,Y-1,nPage,nColor2,cText);
 xPrintf(X,Y+1,nPage,nColor2,cText);

 xPrintf(X+0,Y+0,nPage,nColor1,cText);
End;

Procedure ShadowPrint(X,Y,nPage,nCor1,nCor2:Word; cText:String);
begin
  xprintf(X+1, Y+1, nPage, nCor2, cText);
  xprintf(X  , Y+1, nPage, nCor2, cText);
  xprintf(X, Y, nPage, nCor1, cText);
end;

Procedure Border (X1,Y1,X2,Y2,nPage:Integer; lFlag:Boolean);
Begin
  if lFlag then begin
    {
    xLine (X1+1,Y1,X2-1,Y1,nWhite,nPage);
    xLine (X2,Y1+1,X2,Y2-1,nWhite,nPage);
    xLine (X2-1,Y2,X1+1,Y2,nDarkGray,nPage);
    xLine (X1,Y2-1,X1,Y1+1,nDarkGray,nPage);
    }
    xLine(X1, Y2, X1, Y1, nDarkGray, nPage);
    xLine(X1, Y1, X2, Y1, nDarkGray, nPage);
    xLine(X2, Y1, X2, Y2, nWhite, nPage);
    xLine(X2, Y2, X1, Y2, nWhite, nPage);
  end
  else begin
    {
    xLine (X1+1,Y1,X2-1,Y1,nDarkGray,nPage);
    xLine (X2,Y1+1,X2,Y2-1,nDarkGray,nPage);
    xLine (X2-1,Y2,X1+1,Y2,nWhite,nPage);
    xLine (X1,Y2-1,X1,Y1+1,nWhite,nPage);
    }
    xLine(X1, Y2, X1, Y1, nWhite, nPage);
    xLine(X1, Y1, X2, Y1, nWhite, nPage);
    xLine(X2, Y1, X2, Y2, nDarkGray, nPage);
    xLine(X2, Y2, X1, Y2, nDarkGray, nPage);
  end;
End;



Procedure xRectangle (X1,Y1,X2,Y2,nCor,nPage:Integer);
Begin
xLine (X1,Y1,X2,Y1,nCor,nPage);
xLine (X2,Y1,X2,Y2,nCor,nPage);
xLine (X2,Y2,X1,Y2,nCor,nPage);
xLine (X1,Y2,X1,Y1,nCor,nPage);
End;

function xTextWidth(cStr: String): LongInt;
var
  I, J: LongInt;
begin
  J := 0;
  for i := 1 to Length(cStr) do
    J := J+xGetCharWidth(cStr[i]);
  xTextWidth := j
end;

procedure MapSystemColor;
var
  I, J: Integer;
  nDist: Real;
  aDist: array[0..15] of Real;
  aResult: array[0..15] of Byte;
begin
  nLastBlack := nBlack;
  nLastBlue := nBlue;
  nLastGreen := nGreen;
  nLastCyan := nCyan;
  nLastRed := nRed;
  nLastMagenta := nMagenta;
  nLastBrown := nBrown;
  nLastLightGray := nLightGray;
  nLastDarkGray := nDarkGray;
  nLastLightBlue := nLightBlue;
  nLastLightGreen := nLightGreen;
  nLastLightCyan := nLightCyan;
  nLastLightRed := nLightRed;
  nLastLightMagenta := nLightMagenta;
  nLastYellow := nYellow;
  nLastWhite := nWhite;
  for i := 0 to 15 do
    aDist[i] := 99999;


  for i := 1 to 255 do
    for j := 0 to 15 do begin
      nDist := Abs(Sqr(aPalette[i].R-Palette16[j].R/63*255)+
                   Sqr(aPalette[i].G-Palette16[j].G/63*255)+
                   Sqr(aPalette[i].B-Palette16[j].B/63*255));
      if nDist<aDist[j] then begin
        aDist[j] := nDist;
        aResult[j] := i;
      end;
    end;

  nBlack := aResult[0];
  nBlue := aResult[1];
  nGreen := aResult[2];
  nCyan:= aResult[3];
  nRed := aResult[4];
  nMagenta := aResult[5];
  nBrown := aResult[6];
  nLightGray := aResult[7];
  nDarkGray := aResult[8];
  nLightBlue := aResult[9];
  nLightGreen := aResult[10];
  nLightCyan:= aResult[11];
  nLightRed := aResult[12];
  nLightMagenta := aResult[13];
  nYellow := aResult[14];
  nWhite := aResult[15];

  for j := 1 to MAX_BUTTON_SPRITES do
    with oButtonSprite[j]^ do begin
      for i := 0 to nW*nH-1 do begin
        if aData[i]=0 then begin
        end
        else if aData[i]=nLastBlack then
          aData[i] := nBlack
        else if aData[i]=nLastBlue then
          aData[i] := nBlue
        else if aData[i]=nLastGreen then
          aData[i] := nGreen
        else if aData[i]=nLastCyan then
          aData[i] := nCyan
        else if aData[i]=nLastRed then
          aData[i] := nRed
        else if aData[i]=nLastMagenta then
          aData[i] := nMagenta
        else if aData[i]=nLastBrown then
          aData[i] := nBrown
        else if aData[i]=nLastLightGray then
          aData[i] := nLightGray
        else if aData[i]=nLastDarkGray then
          aData[i] := nDarkGray
        else if aData[i]=nLastLightBlue then
          aData[i] := nLightBlue
        else if aData[i]=nLastLightGreen then
          aData[i] := nLightGreen
        else if aData[i]=nLastLightCyan then
          aData[i] := nLightCyan
        else if aData[i]=nLastLightRed then
          aData[i] := nLightRed
        else if aData[i]=nLastLightMagenta then
          aData[i] := nLightMagenta
        else if aData[i]=nLastYellow then
          aData[i] := nYellow
        else if aData[i]=nLastWhite then
          aData[i] := nWhite;
      end
  end;

end;


  procedure xPutMaskedLBM(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer); assembler;
  var
    I, J, nPos, nX, nDelta: Integer;
  asm
    mov  dh, byte ptr nDC

    mov  ax, ScrnLogicalByteWidth
    mul  Y

    les  di, oSprite
    xor  ch, ch

@LoopLin:
    xor  cl, cl

@LoopCol:
    mov  dl, byte ptr es:[di]

    or   dl, dl
    jz   @DontPutPixel
    add  dl, byte ptr nDC


    push es
    push cx
    push dx
    push ax

    mov  dx,SCREENSEG
    mov  es,dx

    xor  ch, ch
    mov  bx,X
    add  bx, cx
    shr  bx,2
    add  bx,ax
    add  bx,PgOfs

    add  cl,byte ptr X
    and  cl,011b
    mov  ax,0100h + MAPMASK
    shl  ah,cl
    mov  dx,SCINDEX
    out  dx,ax

    pop  ax
    pop  dx
    pop  cx

    mov  es:[bx], dl
    pop  es


@DontPutPixel:
    inc  di
    inc  cl
    cmp  cl, byte ptr w
    jl   @LoopCol


    inc  ch
    add  ax, ScrnLogicalByteWidth
    cmp  ch, byte ptr h
    jl   @LoopLin

    pop  es
  end;

  procedure xPutMaskedLBMFlipY(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer); assembler;
  var
    I, J, nPos, nX, nDelta: Integer;
  asm
    mov  dh, byte ptr nDC

    mov  ax, ScrnLogicalByteWidth
    mov  bx, word ptr y
    mov  cl, byte ptr h
    xor  ch, ch
    add  bx, cx
    mul  bx

    les  di, oSprite
    xor  ch, ch

@LoopLin:
    xor  cl, cl

@LoopCol:
    mov  dl, byte ptr es:[di]

    or   dl, dl
    jz   @DontPutPixel
    add  dl, byte ptr nDC


    push es
    push cx
    push dx
    push ax

    mov  dx,SCREENSEG
    mov  es,dx

    xor  ch, ch
    mov  bx,X
    add  bx, cx
    shr  bx,2
    add  bx,ax
    add  bx,PgOfs

    add  cl,byte ptr X
    and  cl,011b
    mov  ax,0100h + MAPMASK
    shl  ah,cl
    mov  dx,SCINDEX
    out  dx,ax

    pop  ax
    pop  dx
    pop  cx

    mov  es:[bx], dl
    pop  es


@DontPutPixel:
    inc  di
    inc  cl
    cmp  cl, byte ptr w
    jl   @LoopCol


    inc  ch
    sub  ax, ScrnLogicalByteWidth
    cmp  ch, byte ptr h
    jl   @LoopLin

    pop  es
  end;



  procedure xPutMaskedLBMFlipX(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer); assembler;
  var
    I, J, nPos, nX, nDelta: Integer;
  asm
    mov  dh, byte ptr nDC

    mov  ax, ScrnLogicalByteWidth
    mul  Y

    les  di, oSprite
    mov  ch, 0
    mov  cl, byte ptr w
    dec  cx
    add  di, cx

    xor  ch, ch

@LoopLin:
    xor  cl, cl

@LoopCol:
    mov  dl, byte ptr es:[di]

    or   dl, dl
    jz   @DontPutPixel
    add  dl, byte ptr nDC


    push es
    push cx
    push dx
    push ax

    mov  dx,SCREENSEG
    mov  es,dx

    xor  ch, ch
    mov  bx,X
    add  bx, cx
    shr  bx,2
    add  bx,ax
    add  bx,PgOfs

    add  cl,byte ptr X
    and  cl,011b
    mov  ax,0100h + MAPMASK
    shl  ah,cl
    mov  dx,SCINDEX
    out  dx,ax

    pop  ax
    pop  dx
    pop  cx

    mov  es:[bx], dl
    pop  es


@DontPutPixel:
    dec  di
    inc  cl
    cmp  cl, byte ptr w
    jl   @LoopCol


    inc  ch
    mov  bl, byte ptr w
    mov  bh, 0
    add  di, bx
    add  di, bx
    add  ax, ScrnLogicalByteWidth
    cmp  ch, byte ptr h
    jl   @LoopLin

    pop  es
  end;


  procedure xPutMaskedLBMFlipXY(x, y, PgOfs: Integer; w, h, nDC: byte; oSprite: Pointer); assembler;
  var
    I, J, nPos, nX, nDelta: Integer;
  asm
    mov  dh, byte ptr nDC

    mov  ax, ScrnLogicalByteWidth
    mov  bx, word ptr y
    mov  cl, byte ptr h
    xor  ch, ch
    add  bx, cx
    mul  bx

    les  di, oSprite
    mov  ch, 0
    mov  cl, byte ptr w
    dec  cx
    add  di, cx

    xor  ch, ch

@LoopLin:
    xor  cl, cl

@LoopCol:
    mov  dl, byte ptr es:[di]

    or   dl, dl
    jz   @DontPutPixel
    add  dl, byte ptr nDC


    push es
    push cx
    push dx
    push ax

    mov  dx,SCREENSEG
    mov  es,dx

    xor  ch, ch
    mov  bx,X
    add  bx, cx
    shr  bx,2
    add  bx,ax
    add  bx,PgOfs

    add  cl,byte ptr X
    and  cl,011b
    mov  ax,0100h + MAPMASK
    shl  ah,cl
    mov  dx,SCINDEX
    out  dx,ax

    pop  ax
    pop  dx
    pop  cx

    mov  es:[bx], dl
    pop  es


@DontPutPixel:
    dec  di
    inc  cl
    cmp  cl, byte ptr w
    jl   @LoopCol


    inc  ch
    mov  bl, byte ptr w
    mov  bh, 0
    add  di, bx
    add  di, bx
    sub  ax, ScrnLogicalByteWidth
    cmp  ch, byte ptr h
    jl   @LoopLin

    pop  es
  end;


  procedure asmPutBitMap90(x, y, PgOfs: Integer; nDC: byte; oSprite: Pointer); assembler;
  var
    I, J, nPos, nX, nDelta: Integer;
  asm
    mov  ax, ScrnLogicalByteWidth
    mul  Y

    les  di, oSprite
    xor  ch, ch

  @LoopLin:
    xor  cl, cl

  @LoopCol:
    xor  bx, bx

    mov  bl, ch
    shl  bl, 3
    add  bl, cl

    mov  dl, byte ptr es:[di+bx]

    or   dl, dl
    jz   @DontPutPixel
    add  dl, byte ptr nDC


    push es
    push cx
    push dx
    push ax

    mov  dx,SCREENSEG
    mov  es,dx

    xor  ch, ch
    mov  bx,X
    add  bx, cx
    shr  bx,2
    add  bx,ax
    add  bx,PgOfs

    add  cl,byte ptr X
    and  cl,011b
    mov  ax,0100h + MAPMASK
    shl  ah,cl
    mov  dx,SCINDEX
    out  dx,ax

    pop  ax
    pop  dx
    pop  cx

    mov  es:[bx], dl
    pop  es


  @DontPutPixel:
    inc  cl
    cmp  cl, 8
    jl   @LoopCol


    inc  ch
    add  ax, ScrnLogicalByteWidth
    cmp  ch, 8
    jl   @LoopLin

    pop  es
  end;



End.