{$O+}

unit
  UInvad;

interface

uses
  UZ80Var, UKBD, XLIB2, UGraph, UStrings, UZ80, XBM2, UDefault, SMIX;

var
  Sound: array[0..8] of PSound;

procedure InvadersPutByte(nEnder, nValue: Word);
function InvadersGetByte(nEnder: Word): Byte;
function InvadersInByte(nPort: Word): Byte;
procedure InvadersOutByte(nEnder, nValue: Word);
procedure InvadersInterrupt;


implementation

const
  bBitmap: Byte = 0;
  bBitmapPrevious: Byte = 0;
  bShiftValue: Byte = 0;
  bSound1: Byte = 0;
  bSound2: Byte = 0;
  nIntCont: LongInt = 0;

procedure InvadersPutByte(nEnder, nValue: Word);
var
  b, c, d, x, y: Integer;
begin
  if (nEnder<$2000) then exit;
  aZ80Mem^[nEnder] := nValue;
  if (nEnder>$23FF) and (nEnder<=$3FFF) then begin
    x := (nEnder-$2400) shr 5;
    y := (nEnder-$2400) and $1f;
    c := 15;
    if (y<8) then c:=2;
    if (y>23) and (y<28) then c:=4;
    for b:= 0 to 7 do begin

      if (nValue and $01)=0 then
        d := 0
      else
        d := c;
      if xGetPix(nXPos+x, nYPos+256-((y shl 3)+b), VisiblePageOffs)<>d then begin
        if lShowMouse then XHideMouse;
        xPutPix(nXPos+x, nYPos+256-((y shl 3)+b), VisiblePageOffs, d);
        if lShowMouse then XSHowMouse;
        lScreenChanged := true;
      end;
      nValue := nValue shr 1;
    end;
  end;
end;


function InvadersGetByte(nEnder: Word): Byte;
begin
  InvadersGetByte := (aZ80Mem^[nEnder]);
end;

function InvadersInByte(nPort: Word): Byte;
var
  wValue: Word;
  nValue: Byte;
begin
  case nPort of
    1: begin
      nValue := $81;
      {$ifndef DEBUG}
      if oKBD.Key(k1) then nValue := nValue or $04;
      if oKBD.Key(k2) then nValue := nValue or $02;
      if oKBD.Key(k3) then nValue := nValue and (not $01);
      if oKBD.Key(klf) then nValue := nValue or $20;
      if oKBD.Key(krt) then nValue := nValue or $40;
      if oKBD.Key(kctrl) then nValue := nValue or $10;
      {$endif}
      InvadersInByte := nValue;
    end;
    2: begin
       nValue := $0;
       {$ifndef DEBUG}
       if oKBD.Key(kT) then nValue := nValue or $04;
       if oKBD.Key(kP) then nValue := nValue or $08;
       {$endif}
       InvadersInByte := nValue;
    end;
    3: begin
      wValue := (bBitmap shl 8) or bBitmapPrevious;
      wValue := wValue shl bShiftValue;
      nValue := wValue shr 8;
      InvadersInByte := nValue;
    end
    else begin
      InvadersInByte := 0;
    end;
  end;
end;


procedure InvadersOutByte(nEnder, nValue: Word);
begin
  case nEnder of
    2: bShiftValue := nValue;
    3: begin
      if lSound then begin
        if ((nValue and $01)<>0) and (((not bSound1) and $01)<>0) then StartSound(Sound[0], 0, true);
        if (((not nValue) and $01)<>0) and ((bSound1 and $01)<>0) then StopSound(0);
        if ((nValue and $02)<>0) and ((( not bSound1) and $02)<>0) then StartSound(Sound[1], 1, true);
        if (((not nValue) and $02)<>0) and ((bSound1 and $02)<>0) then StopSound(1);
        if ((nValue and $04)<>0) and (((not bSound1) and $04)<>0) then StartSound(Sound[2], 2, true);
        if (((not nValue) and $04)<>0) and ((bSound1 and $04)<>0) then StopSound(2);
        if ((nValue and $08)<>0) and (((not bSound1) and $08)<>0) then StartSound(Sound[3], 3, true);
        if (((not nValue) and $08)<>0) and (( bSound1 and $08)<>0) then StopSound(3);
      end;
      bSound1 := nValue;
    end;
    4: begin
      bBitmapPrevious := bBitmap;
      bBitmap := nValue;
    end;
    5: begin
      if lSound then begin
        if ((nValue and $01)<>0) and (((not bSound2) and $01)<>0) then StartSound(Sound[4], 4, false);
        if ((nValue and $02)<>0) and (((not bSound2) and $02)<>0) then StartSound(Sound[5], 5, false);
        if ((nValue and $04)<>0) and (((not bSound2) and $04)<>0) then StartSound(Sound[6], 6, false);
        if ((nValue and $08)<>0) and (((not bSound2) and $08)<>0) then StartSound(Sound[7], 7, false);
        if ((nValue and $10)<>0) and (((not bSound2) and $10)<>0) then StartSound(Sound[8], 7, true);
        if (((not nValue) and $10)<>0) and (( bSound2 and $08)<>0) then StopSound(7);
        bSound2 := nValue;
      end;
    end;
  end;
end;


procedure InvadersInterrupt;
var
  I, J: Integer;
begin
  DefaultCheckKeyboard;
  Inc(nIntCont);

  if (nIntCont mod 2)=0 then begin
    aProcs[1].nPendingNMI := 0;
    aProcs[1].nPendingIRQ := $000000D7;

    {
    aProcs[1].nPendingNMI := 1;
    aProcs[1].nNMIInt := $10;
    }
    {aZ80Regs^.IFF2 := 1;}
  end
  else begin
    aProcs[1].nPendingNMI := 0;
    aProcs[1].nPendingIRQ := $000000CF; { FORCES A RST 8 }
    {aProcs[1].nNMIInt := $08;}
  end;

  if MouseButtonStatus<>0 then begin
    if lShowMouse then xHideMouse;
    while MouseButtonStatus<>0 do;
    if nXPos<=8 then begin
      lShowMouse := false;
      nXPos := ((GetMaxX-32*8) div 2);
      xRectFill(0, 0, GetMaxX, GetMaxY, HIDDENPAGEOFFS, nBLACK);

      for i := 0 to 255 do
        for j := 0 to 255 do
          xputpix(nXPos+i, nYPos+j, HIDDENPAGEOFFS, xgetpix(8+i, nYPos+j, VISIBLEPAGEOFFS));

      XPageFlip(0, 0);
    end
    else begin
      lShowMouse := true;
      xRectFill(0, 0, GetMaxX, GetMaxY, HIDDENPAGEOFFS, nBLACK);

      for i := 0 to 255 do
        for j := 0 to 255 do
          xputpix(8+i, nYPos+j, HIDDENPAGEOFFS, xgetpix(nXPos+i, nYPos+j, VISIBLEPAGEOFFS));

      nXPos := 8;
      Border(nXPos-2, nYPos-2, nXPos+32*8+2, nYPos+32*8+2, HIDDENPAGEOFFS, false);
      XPageFlip(0, 0);
    end;
    if lShowMouse then xShowMouse;
  end;

  if {lShowCPU} nXPos<=8 then begin
    if lShowMouse then xHideMouse;
    DefaultInfo(VISIBLEPAGEOFFS);
    if lShowMouse then xShowMouse;
  end;

end;


end.