{$O-}

Unit UKBD;  {for now, ignores extended codes ($E0 prefix)}

Interface

Type
  scanCode = (
    kNone, kEsc, k1, k2, k3, k4, k5, k6, k7, k8, k9, k0, kMinus, kEqual,
    kBack, kTab, kQ, kW, kE, kR, kT, kY, kU, kI, kO, kP, kLBracket,
    kRBracket, kEnter, kCtrl, kA, kS, kD, kF, kG, kH, kJ, kK, kL, kColon,
    kQuote, kTilde, kLShift, kBackSlash, kZ, kX, kC, kV, kB, kN, kM, kComma,
    kPeriod, kSlash, kRShift, kPadStar, kAlt, kSpace, kCaps, kF1, kF2, kF3,
    kF4, kF5, kF6, kF7, kF8, kF9, kF10, kNum, kScroll, kHome, kUp, kPgUp,
    kPadMinus, kLf, kPad5, kRt, kPadPlus, kend, kDn, kPgDn, kIns, kDel,
    kSysReq, kUnknown55, kUnknown56, kF11, kF12);


Var
 keyboard : set of scanCode;
 lastKeyDown : scanCode;

type
  TKeyboard = object
    constructor Init;
    function    Key(nKey: ScanCode): boolean;
    destructor  Done;
  end;

  var
   oKBD: TKeyboard;


Implementation
Uses Dos;

Var
  oldKeyInt : Pointer;


Procedure keyISR; interrupt;
Var
  k : scanCode;
  b : Byte;
begin
  Asm
   in al, $60;
   mov b, al;
   and al, $7F;
   mov k, al;
   pushF;
   call [oldKeyInt];      {allow BIOS to process also}
  end;
  memW[$40 : $1A] := memW[$40 : $1C];  {clear BIOS keyboard buffer}
  if shortint(b) >= 0 then
  begin
    keyboard := keyboard + [k];
    lastKeyDown := k;
  end
  else
  if b <> $E0 then
    keyboard := keyboard - [k]
  else ;
end;


Constructor TKeyboard.Init;
var Regs: Registers;
begin
  with Regs do
  begin
    AX := $0305;
    BH := 0;
    BL := 0;
    Intr($16,Regs)
  end;
  keyboard := [];
  lastKeyDown := kNone;
  getIntVec(9, oldKeyInt);
  setIntVec(9, @KeyISR);
end;


function TKeyboard.Key(nKey: ScanCode): boolean;
begin
  Key := nKey in KeyBoard;
end;


Destructor TKeyboard.Done;
var Regs: Registers;
begin
  setIntVec(9, oldKeyInt);
  with Regs do
  begin
    AX := $0305;
    BH := 1;
    BL := 0;
    Intr($16,Regs)
  end;
end;


end.
